    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * --------------------------
    028 * DateObjectDescription.java
    029 * --------------------------
    030 * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: DateObjectDescription.java,v 1.4 2005/11/14 11:01:31 mungady Exp $
    036 *
    037 * Changes (from 19-Feb-2003)
    038 * -------------------------
    039 * 19-Feb-2003 : Added standard header and Javadocs (DG);
    040 * 29-Apr-2003 : Distilled from the JFreeReport project and moved into JCommon
    041 *
    042 */
    043
    044package org.jfree.xml.factory.objects;
    045
    046import java.util.Calendar;
    047import java.util.Date;
    048import java.util.GregorianCalendar;
    049
    050/**
    051 * An object-description for a <code>Date</code> object.
    052 *
    053 * @author Thomas Morgner
    054 */
    055public class DateObjectDescription extends AbstractObjectDescription {
    056
    057    /**
    058     * Creates a new object description.
    059     */
    060    public DateObjectDescription() {
    061        super(Date.class);
    062        setParameterDefinition("year", Integer.class);
    063        setParameterDefinition("month", Integer.class);
    064        setParameterDefinition("day", Integer.class);
    065    }
    066
    067    /**
    068     * Creates an object based on this description.
    069     *
    070     * @return The object.
    071     */
    072    public Object createObject() {
    073        final int y = getIntParameter("year");
    074        final int m = getIntParameter("month");
    075        final int d = getIntParameter("day");
    076
    077        return new GregorianCalendar(y, m, d).getTime();
    078    }
    079
    080    /**
    081     * Returns a parameter value as an <code>int</code>.
    082     *
    083     * @param param  the parameter name.
    084     *
    085     * @return The parameter value.
    086     */
    087    private int getIntParameter(final String param) {
    088        final Integer p = (Integer) getParameter(param);
    089        if (p == null) {
    090            return 0;
    091        }
    092        return p.intValue();
    093    }
    094
    095    /**
    096     * Sets the parameters of this description object to match the supplied object.
    097     *
    098     * @param o  the object (should be an instance of <code>Date</code>).
    099     *
    100     * @throws ObjectFactoryException if the object is not an instance of <code>Date</code>.
    101     */
    102    public void setParameterFromObject(final Object o) throws ObjectFactoryException {
    103        if (o instanceof Date) {
    104            final GregorianCalendar gc = new GregorianCalendar();
    105            gc.setTime((Date) o);
    106            final int year = gc.get(Calendar.YEAR);
    107            final int month = gc.get(Calendar.MONTH);
    108            final int day = gc.get(Calendar.DAY_OF_MONTH);
    109
    110            setParameter("year", new Integer(year));
    111            setParameter("month", new Integer(month));
    112            setParameter("day", new Integer(day));
    113        }
    114        else {
    115            throw new ObjectFactoryException("Is no instance of java.util.Date");
    116        }
    117
    118    }
    119}